Subject: Re: [PATCH RFC] ipv6: fix route selection if kernel is not compiled with CONFIG_IPV6_ROUTER_PREF

From: Nicolas Dichtel <[email-masked]>
Date: Wed, 10 Jul 2013 14:22:55 +0200

Le 10/07/2013 12:53, Hannes Frederic Sowa a écrit :
> On Wed, Jul 10, 2013 at 11:28:57AM +0200, Nicolas Dichtel wrote:
>> Le 10/07/2013 09:54, Nicolas Dichtel a écrit :
>>> Le 09/07/2013 23:57, Hannes Frederic Sowa a écrit :
>>>> After starting a ping6 2000::1 the box should panic soon, after the
>>>> first nexthop entry times out.
>>>>
>>>> Perhaps you could give me a hint?
>>> I will run some tests with your patch. Will see.
>> I don't reproduce this panic.
>
> I just dumped the routes for which it does increase the rt6i_nsiblings
> counter in this condition:
>
>                          /* If we have the same destination and the same metric,
>                           * but not the same gateway, then the route we try to
>                           * add is sibling to this route, increment our counter
>                           * of siblings, and later we will add our route to the
>                           * list.
>                           * Only static routes (which don't have flag
>                           * RTF_EXPIRES) are used for ECMPv6.
>                           *
>                           * To avoid long list, we only had siblings if the
>                           * route have a gateway.
>                           */
>                          if (rt->rt6i_flags & RTF_GATEWAY &&
>                              !(rt->rt6i_flags & RTF_EXPIRES) &&
>                              !(iter->rt6i_flags & RTF_EXPIRES))
>                                  rt->rt6i_nsiblings++;
>                                  dump_route(iter, "(iter)");
>                                  dump_route(rt, "(rt)");
> 			}
>
>
>
> Here:
>
> [   42.497470] (iter): ffff88011796cc00 dst 2000::1 plen 128 gateway 2001:db8::32, siblings 2, metric 0, expires 0 gateway 2 idev6 ffff8801139ddc00 dev ffff880117e83000
> [   42.505912] (rt): ffff88011796d800 dst 2000::1 plen 128 gateway fe80::5054:ff:fe82:e153, siblings 1, metric 0, expires 0 gateway 2 idev6 ffff880117edc400 dev ffff8801185cb000
> [   42.527241] (iter): ffff88011796d380 dst 2000::1 plen 128 gateway 2001:db8::33, siblings 2, metric 0, expires 0 gateway 2 idev6 ffff8801139ddc00 dev ffff880117e83000
> [   42.536440] (rt): ffff88011796d800 dst 2000::1 plen 128 gateway fe80::5054:ff:fe82:e153, siblings 2, metric 0, expires 0 gateway 2 idev6 ffff880117edc400 dev ffff8801185cb000
>
>  From my understanding these two routes should not be aggregated in one ecmp
> route set. Am I seeing this correct? (My configuration is like in the mail
> before.)
Hmm, why?
Routes have the same destination, same metric, are static (expires == 0) and 
have a gateway.

nsiblings counts the number of siblings and does not contains ourself, hence 
both iter should be 1, not 2.

Nicolas